(set-logic QF-UFLIA)


(declare-sort Loc)
(declare-sort Set)
(declare-sort MSet)

(declare-fun singleton (Int) Set)
(declare-fun union (Set Set) Set)
(declare-fun inter (Set Set) Set)
(declare-fun emptyset () Set)
(declare-fun in (Int Set) Bool)
(declare-fun subset (Set Set) Bool)
(declare-fun leq (Set Set) Bool)
(declare-fun eq (Set Set) Bool)

(declare-fun msingleton (Int) MSet)
(declare-fun munion (MSet MSet) MSet)
(declare-fun minter (MSet MSet) MSet)
(declare-fun emptymset () MSet)
(declare-fun msubset (MSet MSet) Bool)
(declare-fun mleq (MSet MSet) Bool)
(declare-fun meq (MSet MSet) Bool)

(declare-fun count (MSet Int) Int)


(declare-fun nil () Loc)
(declare-fun key (Loc) Int)
(declare-fun next (Loc) Loc)
(declare-fun sorted (Loc) Bool)
(declare-fun keys (Loc) MSet)

(assert (sorted nil))
(assert (meq (keys nil) emptymset))


; Vars
(declare-fun x () Loc)
(declare-fun w1 () Int)
(declare-fun w2 () Int)











(assert (not (in w1 emptyset)))
(assert (not (in w2 emptyset)))






(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) w1) (count emptymset w1))))
(assert (=> (meq (keys nil) emptymset) (= (count (keys nil) w2) (count emptymset w2))))
(assert (=> (meq (keys x) (keys nil)) (= (count (keys x) w1) (count (keys nil) w1))))
(assert (=> (meq (keys x) (keys nil)) (= (count (keys x) w2) (count (keys nil) w2))))




(assert (= (count emptymset w1 ) 0))
(assert (= (count emptymset w2 ) 0))

(assert (> (count (keys x) w1) 0))
(assert (> (count (keys nil) w1) 0))

(define (unroll-sorted (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
    ) 
    (and
      (not (= arg0 nil))
      (sorted (next arg0))
      (mleq (msingleton (key arg0)) (keys (next arg0)))
    )
))

(define (unroll-negsorted (arg0 Loc))
  (not (or
    (and 
      (= arg0 nil)
    ) 
    (and
      (not (= arg0 nil))
      (sorted (next arg0))
      (or 
         (mleq (msingleton (key arg0)) (keys (next arg0)))
         (not (< w2 w1))
         (= (count (msingleton (key arg0)) w1) 0)
         (= (count (keys (next arg0)) w2) 0)
      )
    )
)))


(define (unroll-keys (arg0 Loc))
  (or
    (and 
      (= arg0 nil)
      (meq (keys arg0) emptymset)
    )
    (and
      (not (= arg0 nil))
      (meq (keys arg0) (munion (keys (next arg0)) (msingleton (key arg0))))
    )
))


(define (insert-precondition (arg0 Loc))
  (sorted (arg0))
)

(define (insert-postcondition (arg0 Loc) (arg1 Loc) (arg2 Int))
  (and 
    (sorted (arg1))
    (meq (munion (keys arg0) (msingleton arg2)) (keys arg1))
  )
)

(define (postcondition (arg0 Loc) (arg1 Loc))
  (and 
    (sorted (arg1))
    (meq (keys arg0) (keys arg1))
  )
)

(define (negpostcondition (arg0 Loc) (arg1 Loc))
  (or
    (not (sorted (arg1)))
    (and 
       (not (meq (keys arg0) (keys arg1)))
       (not (= (count (keys arg0) w1) (count (keys arg1) w1)))
    )
  )
)



; Path1

(declare-fun p1vc1 () Bool)
(assert (iff p1vc1
  (=> 
     (and
       (= x nil)
     )
     (not (negpostcondition x nil))
  )
))



(assert (not p1vc1))
(check-sat)
(model)